'***************** Simple Archiver ********************
' Purpose:
' SFA copies all selected files into one single file.
' That single file can be easily transferred by xmodem
' and the stored files can be extracted with an editor.
'
' Outlook:
' It should be easy to write a small extraction program.
'
'      For  demonstration  only
'      Use  it on your own risk
'      2/2023 by Twofingers@TBS
'      for  CMM2 and  Picomites
'
' Tested with:
' PicoMite MMBasic Version 5.07.06 and
' PicoMiteWeb V5.07.07a16 and CMM2 5.07.00
'
'******************************************************

Option explicit
Option base 0

Const VERSION$="v0.7"
Const TRUE =1
Const FALSE=Not TRUE

Const MAXFILES%=200
Const ARCHIVEFILE$="Archive.sfa"
Const EXCLUDEFILE$=""     'exclude one single file for "ArchiveFiles_0"

Dim FileName$="", FileMask$="*.bas",Confirm$
Dim FileCount%=0
Dim FileExists%,FIndex%
Dim FSize%,TotalFSize%
Dim FileList$(MAXFILES%)


Print "#####################################################"
Print "   Simple File Archiver "+vERSION$+". Free space = ";: Print MM.Info(FRE
E SPACE)
Print "#####################################################":Print
Print MM.Device$

Pause 1000

If (Dir$(ARCHIVEFILE$, FILE) <> "") Then
  Print ARCHIVEFILE$;
  Input " exist! Overwrite or Append? (O/A) ",Confirm$
EndIf

If UCase$(Confirm$) = "O" Then
  Kill ARCHIVEFILE$
EndIf

Input "FileMask? ",FileMask$
Pause 1000
FileMask$="*.bas"

FileCount%=0
FileName$ = Dir$(FileMask$, FILE)
Do While FileName$ <> ""
   FSize% = MM.Info(FILESIZE FileName$)
   Inc TotalFSize%, FSize%
   Print Str$(FSize%,7), FileName$;
   If FileName$ = EXCLUDEFILE$ Then Print " <excluded>" Else Print
   FileList$(FileCount%) = FileName$
   FileName$ = Dir$()
   Inc FileCount%
Loop

Print FileCount% " files to archive. Total: "Str$(TotalFSize%)" Bytes----------
-----"
Print
Print "Continue to archive these files? ";
Input "Y/N ", Confirm$
If UCase$(Confirm$) = "N" Then Print "Bye!":End

If FileCount% Then
  If Not (Dir$(ARCHIVEFILE$, FILE) <> "") Then
    Open ARCHIVEFILE$ For Append As #1
      Print #1, "Simple Archiver File"
      Print #1
    Close #1
  EndIf
  Print

  DoArchiveFiles_0 '################
  ' please choose DoArchiveFiles, DoArchiveFiles_1 or DoArchiveFiles_2

  Print "========================================================"
  Print findex% " Files added to ";
  Print  ARCHIVEFILE$,Str$(MM.Info(FILESIZE ARCHIVEFILE$),7) " Bytes"
Else
  Print
  Print "Nothing to archive!"
EndIf
End '-----------------------------------------------


Sub AppendFile(FileN$) 'Sub for Sub: DoArchiveFiles_*
  Local f_pos As integer

  Open ARCHIVEFILE$ For append As #1
  Open FileN$ For input As #2

  Print #1,"%&"+FileN$+"&%"

  Do While Not Eof(2)
     On ERROR SKIP 1
     Print #1, Input$(1,#2);
     If MM.Errno<>0 Then
        Print "Error: ";MM.ErrMsg$
        Close #1,#2
        End
     EndIf
     If f_pos Mod 10000 = 0 Then
        If f_pos >= 10000 Then Print "#";f_pos;Chr$(13);
     EndIf

     Inc f_pos
  Loop

  Print #1,"'#SFA#";f_pos
  Print #1,
  Close #1,#2

  If MM.Errno = 0 Then
     'Print "File: " + FileN$ + " successfully appended!"
     Inc FileCount%
  Else
     Print "ERROR @ File: "+ FileN$;
     Print MM.ErrMsg$
  EndIf
End Sub


Sub DoArchiveFiles_0 'works with Picomite and also CMM2
  FileCount%=0
  FIndex% = 1
  Do
    FileName$ = Dir$(FileMask$, FILE)
    If FileCount%=0 Then
       Appendfile(FileName$)
       Print Str$(findex%,4,0)+"  "+FileName$
    Else
       For FIndex%  = 2 To FileCount%+1
          FileName$ = Dir$()
       Next FIndex%
       If FileName$<>"" Then
          Appendfile(FileName$)
          Print Str$(findex%-1,4,0)+"  "+FileName$
       EndIf
    EndIf
  Loop While FileName$ <> ""
  Inc FIndex%,-2
End Sub


Sub DoArchiveFiles_1 ' works on Picomite and CMM2 too
                   ' but only a limiteded number, ie MAXFILES%
  For FIndex% = 0 To FileCount%-1
    If FileList$(FIndex%) <> EXCLUDEFILE$ Then
       Print Str$(FIndex%+1,4,0)+"  "+FileList$(FIndex%)
       Appendfile(FileList$(FIndex%))
    EndIf
  Next FIndex%
End Sub


Sub DoArchiveFiles_2 'works for CMM2 only! On Pico I get unpredictable results.
  FileCount%=0
  FIndex%=0
  FileName$ = Dir$(FileMask$, FILE)
  Do While FileName$ <> ""
     Appendfile(FileName$)
     Print Str$(FIndex%+1,4,0)+"  "+FileName$
     Inc FIndex%
     FileName$ = Dir$()
  Loop
  FIndex% = FileCount%
End Sub


Sub testdata
  Local i ,FN$
  For i = 1 To 100
    FN$="X"+Str$(i,3,0,"#")+".bas"
    Print FN$
    Open FN$ For Append As #1
      Print #1, "TestData Simple Archiver File"
      Print #1
    Close #1
  Next
End Sub